local scale = 4
local ImageD = love.image.newImageData(800/scale,600/scale)
local BAngle = 45
local BX = 100
local BY = 75
local point1 = nil
local Mirrors = {}
local mfloor = math.floor
local mcos = math.cos
local msin = math.sin
local mrad = math.rad
function Ray(px,py,A)
	local moved = 1
	local ux = px
	local uy = py
	local ua = A
	ImageD:mapPixel(function(x,y,r,g,b,a)--remove old ray
		if r == 255 and g == 0 and b == 0 then 
			return 0,0,0,0 
		else 
			return r,g,b,a 
		end
	end)
	while moved < 75 do
		local nx = ux+mfloor(mcos(mrad(ua))*moved+0.5)
		local ny = uy+mfloor(msin(mrad(ua))*moved+0.5)
		if nx < 200 and nx > 1 and ny < 150 and ny > 1 then
			r,g,b,a = ImageD:getPixel(nx,ny)
			if (r == 255 and g == 255 and b == 255) then
				OA = Mirrors[nx..ny]
				ua = OA+(OA-ua)--example = 135+(135-90) = 135+(45) = 180
				ux = nx
				uy = ny
				moved = 0
			else
				nx = ux+mfloor(mcos(mrad(ua))*moved+0.5)
				ny = uy+mfloor(msin(mrad(ua))*moved+0.5)
				ImageD:setPixel(nx,ny,255,0,0,255)
			end
		end
		moved = moved+1
		love.timer.sleep(1)
	end
end
function love.update(dt)
		if love.keyboard.isDown("a") then
			BAngle = BAngle-1
			Ray(BX,BY,BAngle)
		end
		if love.keyboard.isDown("d") then
			BAngle = BAngle+1
			Ray(BX,BY,BAngle)
		end
end
function love.mousepressed(mx,my,b)
	if b == "l" then
		point1 = {x = mx, y = my}
	end
end
function love.mousereleased(mx,my,b)
	if b == "l" then
		local point2 = {x = mx, y = my}
		local sa = math.atan2(point1.x-point2.x,point2.y-point1.y)+math.rad(90)
		for points = 1,((point1.x-point2.x)^2+(point1.y-point2.y)^2)^0.5 do
			local nx = point1.x+mcos(sa)*points
			local ny = point1.y+msin(sa)*points
			nx = mfloor(nx/scale+0.5)
			ny = mfloor(ny/scale+0.5)
			Mirrors[nx..ny] = sa
			ImageD:setPixel(nx,ny,255,255,255,255)	
		end
	end
end
function love.draw()
	DImage = love.graphics.newImage(ImageD)
	DImage:setFilter("nearest","nearest")
	love.graphics.draw(DImage,0,0,0,scale,scale)
	if love.mouse.isDown("l") then
		love.graphics.line(point1.x,point1.y,love.mouse.getX(),love.mouse.getY())
	end
end